// test4_timesec.cpp
// Glenn G. Chappell
// 8 Oct 2013
//
// For CS 202 Fall 2013
// Test program #4 for class TimeSec:
// operator <<

#include "timesec.h"  // For class TimeSec
#include "timesec.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testTimeSec_basic
// Test for class TimeSec: construction & print
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_basic()
{
    cout << endl;
    cout << "Test: construction & print" << endl;

    {
    const TimeSec t;
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 0:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 5:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(12);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "12:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 25);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:25:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(11, 5, 16);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = "11:05:16";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5, 6);
    ostringstream os;
    t.print(os);
    string s = os.str();
    string ans = " 3:05:06";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// testTimeSec_streamOut
// Test for class TimeSec: stream output
// Prints results of tests, sets global allGood to false if any fail
void testTimeSec_streamOut()
{
    cout << endl;
    cout << "Test: stream output" << endl;

    {
    TimeSec t;
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = " 0:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(5);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = " 5:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(12);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = "12:00:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 25);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = " 3:25:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = " 3:05:00";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(11, 5, 16);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = "11:05:16";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t(3, 5, 6);
    ostringstream os;
    os << t;
    string s = os.str();
    string ans = " 3:05:06";
    cout << "String version of time (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }

    {
    TimeSec t;
    TimeSec t2(1, 2, 3);
    ostringstream os;
    os << t << t2;
    string s = os.str();
    string ans = " 0:00:00 1:02:03";
    cout << "String version of 2 times (should be [" << ans << "]): ["
         << s << "]" << endl;
    if (s != ans)
        allGood = false;
    }
}


// main program
// Runs tests for class TimeSec, prints results
int main()
{
    testTimeSec_basic();
    testTimeSec_streamOut();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

